<template>
  <BaseCard v-if="validatedData.documents.length > 0" description="" title="">
    <div class="text-sm font-medium text-gray-700 text-right">Document type:
      {{ this.validatedData.documents[0].document_type }}
    </div>
    <div v-for="f in this.validatedData.documents[0].fields" :key="f.name">
      <label :for="f.name" class="block text-sm font-medium text-gray-700">{{ f.name }}</label>
      <input type="text" :name="f.name" :id="f.name"
             v-model="f.value"
             spellcheck="false"
             class="mt-1 focus:ring-indigo-500 focus:border-indigo-500 block w-full shadow-sm sm:text-sm border-gray-300 rounded-md"/>
    </div>
    <div class="py-3 text-right">
      <button type="submit"
              @click="onSave"
              class="inline-flex justify-center py-2 px-4 border border-transparent shadow-sm text-sm font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500">
        Save
      </button>
    </div>
  </BaseCard>
</template>

<script lang="ts">

import {defineComponent} from 'vue';
import BaseCard from "@/components/BaseCard.vue";
import {ValidateCompleteData, ValidatedDocument, ValidatedField, ValidationStartData} from "@/services/streamResponse";
import {useRoute, useRouter} from "vue-router";
import {streamService} from "@/services/services";
import {RouteNames} from "@/router";

export default defineComponent({
  name: 'Validate',
  components: {
    BaseCard,
  },
  data() {
    return {
      router: useRouter(),
      validationSpec: {} as ValidationStartData,
      streamId: "",
      validatedData: {
        documents: []
      } as ValidateCompleteData,
    }
  },
  async mounted() {
    const route = useRoute()
    const streamStr: string | string[] = route.params.streamId;

    if (typeof streamStr !== "string") {
      alert("documentId route parameter must be a string, not a string array")
      return
    }

    this.streamId = streamStr

    // todo query project execution status before starting validation
    this.validationSpec = await streamService.startValidation(this.streamId)
    console.log("started validation", this.validationSpec)

    this.mapSpecToReviewResults()
  },
  methods: {
    mapSpecToReviewResults() {
      const document = this.validationSpec.documents[0]
      let validatedDocument: ValidatedDocument = {
        document_type: document.document_type,
        fields: []
      }

      document.fields.forEach((field) => {
        let validatedField: ValidatedField = {
          name: field.name,
          value: ""
        }

        if (field.results && field.results.length > 0) {
          validatedField.value = field.results[0].text
        }

        validatedDocument.fields.push(validatedField)
      })

      console.log("validated data", this.validatedData)

      this.validatedData.documents.push(validatedDocument)
    },
    async onSave() {
      await streamService.completeValidation(this.streamId, this.validatedData)

      // Wait for the stream to be ready for either validation or export
      // This method throws an error if the stream goes into an unexpected state
      // For simplicity it does not time out. A real application should not wait forever.
      const nextAction = await streamService.waitForStartClientActionState(this.streamId)

      if (nextAction == "export") {
        await this.router.push({name: RouteNames.Export, params: {streamId: this.streamId}})
      } else {
        alert(`Unexpected next action: ${nextAction}`)
      }
    }
  }
})
</script>
